#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <signal.h>
#include "def.h"
#include <sched.h>


/*This function puts the thread represented by “s_no” into the blocked state. The thread represented by “w_no” is removed from the blocked state and put in the ready state.
*/

inline void sleep_wake_it(int s_no,int w_no)
{
		sched_yield ();
    pthread_mutex_lock( &(condition_mutex[w_no]));
    pthread_cond_signal( &(condition_cond[w_no]) );
    pthread_mutex_unlock( &(condition_mutex[w_no]) );

    pthread_mutex_lock( &(condition_mutex[s_no]));
    pthread_cond_wait( &(condition_cond[s_no]), &(condition_mutex[s_no]) );
    pthread_mutex_unlock( &(condition_mutex[s_no]) );
}
/*This function creates all the threads, the customers, tellers, printer, guard and the scheduler threads.  Then it gives the control to the timer thread and keeps waiting for it to exit.*/
main()
{
    int create_status;
		int i,service_type2,j;
		fp=fopen("log_book.txt","w");
		if(fp==NULL)
		{
			printf("\nLog file could not be opened");
			exit(0);
		}

    initialize();
    thread_id[MAIN]=pthread_self();
    
		
    printf("No. of customers in the bank:");
    scanf("%d",&no_cust);
		if(no_cust>200)
		{
			printf("\nInvalid value");
			exit(0);
		}
		srandom(time(0));
	// Create customer threads 
    for(i=0;i<200;i++)
    {
			service_type[i]=(unsigned int)random()%4;
			service_type2=(unsigned int)random()%2;
			if(service_type[i]>2)
				service_type[i] += service_type2;
			j=(i*10)+service_type[i];
			create_status = pthread_create( &thread_id[i], &attr, f_customer, (void*)j);
    }
    printf("\nAll customers created");

	// Create teller threads
    for(i=0;i<5;i++)
    {
			create_status = pthread_create( &thread_id[TELLER+i], &attr, f_teller, (void*) i);
    }
    printf("\nAll tellers created");
	
	// Create guard thread   
    create_status = pthread_create( &thread_id[GUARD], &attr, f_guard, (void*) NULL);
    printf("\nGuard created");

	     // Create record printer thread 
    create_status = pthread_create( &thread_id[PRINTER], &attr, f_rec_prntr, (void*) NULL);


	     // Create scheduler thread 
    create_status = pthread_create( &thread_id[SCHEDULER], &attr, f_q_schdlr, (void*) NULL);
    printf("\nScheduler created");
     	
    // Create timer thread 
    create_status = pthread_create( &thread_id[TIMER], &attr, f_timer, (void*) NULL);
    printf("\nTimer created");
    pthread_join( thread_id[TIMER], NULL);
		for(i=0;i<210;i++)
    {
			pthread_mutex_destroy(&condition_mutex[i]);
			pthread_cond_destroy(&condition_cond[i]);
    }
		fclose(fp);
}

//This function initializes all the global data structures used.
void initialize()
{
    int i;
    
    for(i=0;i<5;i++)
    {
 			tail[i]=0;
			head[i]=0;
			srvc_time[i]=0;
			cust_no_srvcd[i]=0;
    }
    for(i=0;i<210;i++)
    {
			condition_mutex[i] = (pthread_mutex_t)PTHREAD_MUTEX_INITIALIZER;
			condition_cond[i]  = (pthread_cond_t)PTHREAD_COND_INITIALIZER;
    }
		pthread_attr_setschedpolicy(&attr,SCHED_FIFO);
		pthread_attr_init(&attr);
}


/*
This function is the code for the customer.  There are 200 such threads executing this function.
*/
void *f_customer( void *ptr )
{
    int *recieve;
    int my_no=0,my_req;
    recieve = (int *) ptr;
    my_req=(int)recieve;
    my_req=my_req%10;
    my_no=(int)recieve;
    my_no=my_no/10;
    sleep_wake_it(CUSTOMER+my_no,MAIN);
    	//coustomer woken up by teller
		 	service_requirement=my_req;
    	sleep_wake_it(CUSTOMER+my_no,questioning_teller);//customer returns control back to the corresponding teller
}
//This has the code for the guard thread.
void *f_guard( void *ptr )
{
    static int i=0,x,j;
		sleep_wake_it(GUARD,MAIN);
    for(i=0;i<no_cust;i++)
    {
			guard_insert_q(service_type[i],i);//put a customer in the respective queue
    }
		sleep_wake_it(GUARD,TIMER);
    while(1)
    {
		if(i<200)
		{
	    x=0;
	    for(j=0;j<5;j++)
			x+=tail[j];
	    while((x<200)&&(x<no_cust))
	    {
				guard_insert_q(service_type[i],i);//put a customer in the respective queue
	   		x++;i++;
	    }
		} 
		sleep_wake_it(GUARD,TIMER);
	}
}

//This function schedules the execution of the various threads.
void *f_timer( void *ptr )
{
    int i=0;
    sleep_wake_it(TIMER,GUARD);
    printf("\nFirst lot of customers entered");
    while(cust_srvd!=200)//keep scheduling till all the customers are serviced
    {
    	sleep_wake_it(TIMER,TELLER1);
			sleep_wake_it(TIMER,TELLER2);
			sleep_wake_it(TIMER,TELLER3);
			sleep_wake_it(TIMER,TELLER4);
			sleep_wake_it(TIMER,TELLER5);
  		sleep_wake_it(TIMER,GUARD);
  		sleep_wake_it(TIMER,SCHEDULER);
			sleep_wake_it(TIMER,PRINTER);
			printf("\nServed:%d",cust_srvd);
	}
	for(i=0;i<5;i++)
	{
		fprintf(fp,"\nTeller %d average service time:%f" ,i,(float)srvc_time[i]/(float)cust_no_srvcd[i]);
	}
}

//This thread contains the code for the teller.  There are 5 such threads executing this code.
void *f_teller( void *ptr )
{
    int *recieve;
    int my_no=0;
    int sleep_time,i;
    recieve = (int *) ptr;
    my_no=(int)recieve;
    sleep_wake_it(TELLER+my_no,MAIN);
    while(1)
    {
			if(tail[my_no]==head[my_no])//check for queue empty	
			{
	    	sleep_wake_it(TELLER+my_no,TIMER);
    	}
    	else
    	{
   	    questioning_teller=TELLER+my_no;
   	    sleep_wake_it(TELLER+my_no,queue[my_no][head[my_no]]);//wake up head of queue customer
   	    sleep_time=convert_req_to_time(service_requirement);
				srvc_time[my_no]+=sleep_time;
   	    for(i=0;i<sleep_time;i++)
   	    {
					sleep_wake_it(TELLER+my_no,TIMER);
    	  }
		//customer serviced
				cust_no_srvcd[my_no]++;
	    	adjust_queue(my_no);
    	}
    }
}




//This function maps the service type to the service time.

int convert_req_to_time(int req)
{
    switch(req)
    {
			case(SRVS_PASSBOOK):
	    	return(TIME_A);
			case(SRVS_CHEQUE):
	    	return(TIME_B);
			case(SRVS_DEPOSIT):
	    	return(TIME_X);
			case(SRVS_CHEQUE_W):
	    	return(TIME_Y);
			case(SRVS_ACCOUNT_W):
	    	return(TIME_Z);
    }
}

//This is the code for the printer thread.
void *f_rec_prntr( void *ptr )
{
	sleep_wake_it(PRINTER,MAIN);
	while(1)
	{
		print_q();
		sleep_wake_it(PRINTER,TIMER);
	}
}

//This is the function that actually does the work of balancing the queues. This function is called by the scheduler thread.
void *f_q_schdlr( void *ptr )
{
    int i;
    sleep_wake_it(SCHEDULER,MAIN);
    while(1)
    {
			for(i=0;i<TIME_P;i++)
	    	sleep_wake_it(SCHEDULER,TIMER);
    	fprintf(fp,"\nSchedule\n");
			schedule_q();
			sleep_wake_it(SCHEDULER,TIMER);
    }
}
//this function adjusts a particular queue after a customer has been serviced
void adjust_queue(int q_no)
{
    int i=0;
    while(i!=tail[q_no])
    {
			queue[q_no][i]=queue[q_no][i+1];
			i++;
    }
    tail[q_no]--;
    cust_srvd++;
}

// This function is the scheduler thread.
void schedule_q()
{
	int temp[200];
	int fl=0,i,j,k=0,q_no;

	
		i=1;//leave the head of queue customer
		while(1)
		{
			for(q_no=2;q_no<5;q_no++)
			{
				if(i<tail[q_no])
				{
					temp[k]=queue[q_no][i];
					k++;
					fl=1;
				}
			}
			i++;
			if(fl==0)
			{
				break;
			}
			else
			{
				fl=0;
			}
		}
		q_no=0;
		for(i=2;i<5;i++)
		{
			if(tail[i]>1)
				tail[i]=1;
			if(tail[i]==head[i])
				q_no=i-2;
		}
		i=0;
		fprintf(fp,"\nq_no=%d\n",q_no);
		//q_no=2;
		while(i<k)
		{
			queue[q_no+SRVS_DEPOSIT][tail[q_no+SRVS_DEPOSIT]]=temp[i];//insert customer in a particular queue 
			tail[q_no+SRVS_DEPOSIT]=(tail[q_no+SRVS_DEPOSIT]+1);
			q_no=(q_no+1)%3;//inserts customers in round robin fashion
			i++;
		}
}

//This function is doing the job of writing the current queue information into the log file.
void print_q()
{
    int i,j;
    for(j=0;j<5;j++)
    {
    	i=head[j];
			fprintf(fp,"\nQ %d:  ",j);
    	while(i!=tail[j])
    	{
				fprintf(fp," %lu:%d|",thread_id[queue[j][i]],service_type[queue[j][i]]);
	    	i=(i+1);
    	}
    }
		fprintf(fp,"\n_______________________________________________________________________________________");
		fflush(fp);
}

//This function is used to enter the customer thread id's in the queues inside the bank.
void guard_insert_q(int srvc_type,int c_id)
{
    static int q_no=0,i;
    if((srvc_type==SRVS_PASSBOOK)||(srvc_type==SRVS_CHEQUE))
    {
			queue[srvc_type][tail[srvc_type]]=c_id;//insert customer in a particular 
			tail[srvc_type]=(tail[srvc_type]+1);
    }
    else
    {
      queue[q_no+SRVS_DEPOSIT][tail[q_no+SRVS_DEPOSIT]]=c_id;//insert customer in a particular 
			tail[q_no+SRVS_DEPOSIT]=(tail[q_no+SRVS_DEPOSIT]+1);
			q_no=(q_no+1)%3;//Guard inserts customers in round robin fashion
    }
}














